package dev.usbharu.activitystreamsserialization.model

object Properties {
    const val ID = "@id"
    const val TYPE = "@type"
    const val VALUE = "@value"
    const val LANGUAGE = "@language"
    const val ACTOR = "https://www.w3.org/ns/activitystreams#actor"
    const val OBJECT = "https://www.w3.org/ns/activitystreams#object"
    const val CONTENT = "https://www.w3.org/ns/activitystreams#content"
    const val NAME = "https://www.w3.org/ns/activitystreams#name"
    const val PUBLISHED = "https://www.w3.org/ns/activitystreams#published"
    const val ATTACHMENT = "https://www.w3.org/ns/activitystreams#attachment"
    const val ATTRIBUTED_TO = "https://www.w3.org/ns/activitystreams#attributedTo"
    const val AUDIENCE = "https://www.w3.org/ns/activitystreams#audience"
    const val BCC = "https://www.w3.org/ns/activitystreams#bcc"
    const val BTO = "https://www.w3.org/ns/activitystreams#bto"
    const val CC = "https://www.w3.org/ns/activitystreams#cc"
    const val CONTEXT = "https://www.w3.org/ns/activitystreams#context"
    const val CURRENT = "https://www.w3.org/ns/activitystreams#current"
    const val FIRST = "https://www.w3.org/ns/activitystreams#first"
    const val LAST = "https://www.w3.org/ns/activitystreams#last"
    const val GENERATOR = "https://www.w3.org/ns/activitystreams#generator"
    const val ICON = "https://www.w3.org/ns/activitystreams#icon"
    const val IMAGE = "https://www.w3.org/ns/activitystreams#image"
    const val IN_REPLY_TO = "https://www.w3.org/ns/activitystreams#inReplyTo"
    const val INSTRUMENT = "https://www.w3.org/ns/activitystreams#instrument"
    const val LOCATION = "https://www.w3.org/ns/activitystreams#location"
    const val ITEMS = "https://www.w3.org/ns/activitystreams#items"
    const val ONE_OF = "https://www.w3.org/ns/activitystreams#oneOf"
    const val ANY_OF = "https://www.w3.org/ns/activitystreams#anyOf"
    const val CLOSED = "https://www.w3.org/ns/activitystreams#closed"
    const val ORIGIN = "https://www.w3.org/ns/activitystreams#origin"
    const val NEXT = "https://www.w3.org/ns/activitystreams#next"
    const val PREV = "https://www.w3.org/ns/activitystreams#prev"
    const val PREVIEW = "https://www.w3.org/ns/activitystreams#preview"
    const val RESULT = "https://www.w3.org/ns/activitystreams#result"
    const val REPLIES = "https://www.w3.org/ns/activitystreams#replies"
    const val TAG = "https://www.w3.org/ns/activitystreams#tag"
    const val TARGET = "https://www.w3.org/ns/activitystreams#target"
    const val TO = "https://www.w3.org/ns/activitystreams#to"
    const val URL = "https://www.w3.org/ns/activitystreams#url"
    const val ACCURACY = "https://www.w3.org/ns/activitystreams#accurency"
    const val ALTITUDE = "https://www.w3.org/ns/activitystreams#altitude"
    const val DURATION = "https://www.w3.org/ns/activitystreams#duration"
    const val HEIGHT = "https://www.w3.org/ns/activitystreams#height"
    const val WIDTH = "https://www.w3.org/ns/activitystreams#width"
    const val HREF = "https://www.w3.org/ns/activitystreams#href"
    const val HREFLANG = "https://www.w3.org/ns/activitystreams#hreflang"
    const val PART_OF = "https://www.w3.org/ns/activitystreams#partOf"
    const val LATITUDE = "https://www.w3.org/ns/activitystreams#latitute"
    const val LONGITUDE = "https://www.w3.org/ns/activitystreams#longitute"
    const val MEDIA_TYPE = "https://www.w3.org/ns/activitystreams#mediaType"
    const val END_TIME = "https://www.w3.org/ns/activitystreams#endTime"
    const val START_TIME = "https://www.w3.org/ns/activitystreams#startTime"
    const val RADIUS = "https://www.w3.org/ns/activitystreams#radius"
    const val REL = "https://www.w3.org/ns/activitystreams#rel"
    const val START_INDEX = "https://www.w3.org/ns/activitystreams#startIndex"
    const val SUMMARY = "https://www.w3.org/ns/activitystreams#summary"
    const val TOTAL_ITEMS = "https://www.w3.org/ns/activitystreams#totalItems"
    const val UNITS = "https://www.w3.org/ns/activitystreams#units"
    const val UPDATED = "https://www.w3.org/ns/activitystreams#updated"
    const val SUBJECT = "https://www.w3.org/ns/activitystreams#subject"
    const val RELATIONSHIP = "https://www.w3.org/ns/activitystreams#relationship"
    const val DESCRIBES = "https://www.w3.org/ns/activitystreams#describes"
    const val FORMER_TYPE = "https://www.w3.org/ns/activitystreams#formerType"
    const val DELETED = "https://www.w3.org/ns/activitystreams#deleted"
    const val SHARED_INBOX = "https://www.w3.org/ns/activitystreams#sharedInbox"
    const val PROXY_URL = "https://www.w3.org/ns/activitystreams#proxyUrl"
    const val OAUTH_AUTHORIZATION_ENDPOINT = "https://www.w3.org/ns/activitystreams#oauthAuthorizationEndpoint"
    const val OAUTH_TOKEN_ENDPOINT = "https://www.w3.org/ns/activitystreams#oauthTokenEndpoint"
    const val PROVIDE_CLIENT_KEY = "https://www.w3.org/ns/activitystreams#provideClientKey"
    const val SIGN_CLIENT_KEY = "https://www.w3.org/ns/activitystreams#signClientKey"
    const val PREFERRED_USERNAME = "https://www.w3.org/ns/activitystreams#preferredUsername"
    const val INBOX = "http://www.w3.org/ns/ldp#inbox"
    const val OUTBOX = "https://www.w3.org/ns/activitystreams#outbox"
    const val FOLLOWERS = "https://www.w3.org/ns/activitystreams#followers"
    const val FOLLOWING = "https://www.w3.org/ns/activitystreams#following"
    const val LIKED = "https://www.w3.org/ns/activitystreams#liked"
    const val STREAMS = "https://www.w3.org/ns/activitystreams#streams"
    const val ENDPOINTS = "https://www.w3.org/ns/activitystreams#endpoints"
    const val OWNER = "https://w3id.org/security#owner"
    const val PUBLIC_KEY = "https://w3id.org/security#publicKey"
    const val MANUALLY_APPROVES_FOLLOWERS = "https://www.w3.org/ns/activitystreams#manuallyApprovesFollowers"
    const val FEATURED = "http://joinmastodon.org/ns#featured"
    const val DISCOVERABLE = "http://joinmastodon.org/ns#discoverable"
}

object Type {
    const val LINK = "https://www.w3.org/ns/activitystreams#Link"
    const val NOTE = "https://www.w3.org/ns/activitystreams#Note"
    const val ACCEPT = "https://www.w3.org/ns/activitystreams#Accept"
    const val TENTATIVE_ACCEPT = "https://www.w3.org/ns/activitystreams#TentativeAccept"
    const val ADD = "https://www.w3.org/ns/activitystreams#Add"
    const val ARRIVE = "https://www.w3.org/ns/activitystreams#Arrive"
    const val OBJECT = "https://www.w3.org/ns/activitystreams#Object"
    const val IMAGE = "https://www.w3.org/ns/activitystreams#Image"
    const val PERSON = "https://www.w3.org/ns/activitystreams#Person"
    const val APPLICATION = "https://www.w3.org/ns/activitystreams#Application"
    const val GROUP = "https://www.w3.org/ns/activitystreams#Group"
    const val SERVICE = "https://www.w3.org/ns/activitystreams#Service"
    const val ACTIVITY = "https://www.w3.org/ns/activitystreams#Activity"
    const val INTRANSITIVE_ACTIVITY = "https://www.w3.org/ns/activitystreams#IntransitiveActivity"
    const val COLLECTION = "https://www.w3.org/ns/activitystreams#Collection"
    const val ORDERED_COLLECTION = "https://www.w3.org/ns/activitystreams#OrderedCollection"
    const val COLLECTION_PAGE = "https://www.w3.org/ns/activitystreams#CollectionPage"
    const val ORDERED_COLLECTION_PAGE = "https://www.w3.org/ns/activitystreams#OrderedCollectionPage"
    const val CREATE = "https://www.w3.org/ns/activitystreams#Create"
    const val DELETE = "https://www.w3.org/ns/activitystreams#Delete"
    const val FOLLOW = "https://www.w3.org/ns/activitystreams#Follow"
    const val IGNORE = "https://www.w3.org/ns/activitystreams#Ignore"
    const val JOIN = "https://www.w3.org/ns/activitystreams#Join"
    const val LEAVE = "https://www.w3.org/ns/activitystreams#Leave"
    const val LIKE = "https://www.w3.org/ns/activitystreams#Like"
    const val OFFER = "https://www.w3.org/ns/activitystreams#Offer"
    const val INVITE = "https://www.w3.org/ns/activitystreams#Invite"
    const val REJECT = "https://www.w3.org/ns/activitystreams#Reject"
    const val TENTATIVE_REJECT = "https://www.w3.org/ns/activitystreams#TentativeReject"
    const val REMOVE = "https://www.w3.org/ns/activitystreams#Remove"
    const val UNDO = "https://www.w3.org/ns/activitystreams#Undo"
    const val UPDATE = "https://www.w3.org/ns/activitystreams#Update"
    const val VIEW = "https://www.w3.org/ns/activitystreams#View"
    const val LISTEN = "https://www.w3.org/ns/activitystreams#Listen"
    const val READ = "https://www.w3.org/ns/activitystreams#Read"
    const val MOVE = "https://www.w3.org/ns/activitystreams#Move"
    const val TRAVEL = "https://www.w3.org/ns/activitystreams#Travel"
    const val ANNOUNCE = "https://www.w3.org/ns/activitystreams#Announce"
    const val BLOCK = "https://www.w3.org/ns/activitystreams#Block"
    const val FLAG = "https://www.w3.org/ns/activitystreams#Flag"
    const val DISLIKE = "https://www.w3.org/ns/activitystreams#Dislike"
    const val QUESTION = "https://www.w3.org/ns/activitystreams#Question"
    const val ORGANIZATION = "https://www.w3.org/ns/activitystreams#Organization"
    const val RELATIONSHIP = "https://www.w3.org/ns/activitystreams#Relationship"
    const val ARTICLE = "https://www.w3.org/ns/activitystreams#Article"
    const val DOCUMENT = "https://www.w3.org/ns/activitystreams#Document"
    const val AUDIO = "https://www.w3.org/ns/activitystreams#Audio"
    const val VIDEO = "https://www.w3.org/ns/activitystreams#Video"
    const val PAGE = "https://www.w3.org/ns/activitystreams#Page"
    const val EVENT = "https://www.w3.org/ns/activitystreams#Event"
    const val PLACE = "https://www.w3.org/ns/activitystreams#Place"
    const val MENTION = "https://www.w3.org/ns/activitystreams#Mention"
    const val PROFILE = "https://www.w3.org/ns/activitystreams#Profile"
    const val TOMBSTONE = "https://www.w3.org/ns/activitystreams#Tombstone"
}